angular.module('AccesoController', ['ionic'])

.controller('AccesoController', function($translate, $scope, $rootScope, $ionicModal, $ionicLoading, $state, $stateParams, $ionicPopup, $ionicHistory, $ionicPlatform, FactoriaTodo, $cordovaDevice) {

    // *-- ----------- --*
    // *-- - BOTONES - --*
    // *-- ----------- --*
    // Seleccionamos el idioma de la app
    $rootScope.ocultarNavBar = true;
    $translate.use('ar');
    $rootScope.IdiomaSeleccionado='ar';
    console.log($scope.text);
    $scope.dato={};
    $scope.botonClickado = false;
    $scope.mostrarEncuesta = false;
    console.log("scope");
    console.log($scope);


    // *-- Controlamos los eventos de la pulsación atras para android y boton --*
    // Pulsación atrás Android
    var reg = $ionicPlatform.registerBackButtonAction(function() {
      $scope.atras();
    }, 100);
    //eliminar back button
    $scope.$on('$destroy', reg);
    // Pulsacion atrás Cabecera
    $scope.atras = function() {
      // Menu Principal -> Salir

      console.log($translate);
   $ionicPopup.show({
        title: $translate.instant('SALIR'),
        template: "<style>.popup { width:500px; }</style><p>{{'COMENTARIO_SALIR' | translate}}<p/>",
        scope: $scope,
        buttons: [
         { text: $translate.instant('NO') },
         {
           text: "<b>"+$translate.instant('SI')+"</b>",
           type: 'button-positive',
           onTap: function() {
            console.log("SALIR");
              if(window.cordova){
                    ionic.Platform.exitApp();
                }else{
                    $state.go("Acceso");
                }
          }
         }
        ]
      });
    }
    $scope.itCategorias = function(usu){
      console.log("IR CATEGORIAS");
      console.log($rootScope.vengoDeMsg);
      if ( $rootScope.vengoDeMsg){
        //no hacer nada
      }else{
         $state.go('Categorias', {
            usuario: usu
        });
      }

    }
    $scope.cargarCategorias = function(){
         $ionicLoading.show({
              templateUrl: 'views/Extras/cargando.html',
              duration: 30000
          }).then(function() {
            setTimeout(function(){ //esperar a que se rellene isOnline
               console.log(1);
              if($rootScope.isOnline){
                 console.log("CON CONEXION");
                  FactoriaTodo.getCategorias()
                    .success(function(events) {
                      // *-- Cargamos las categorias y subcategorias --*
                      console.log(events);
                      if(events.d==""){
                        $ionicLoading.hide();
                        $rootScope.Categorias = [];
                        $ionicPopup.show({
                            title: $translate.instant('ERROR'),
                            template: "<style>.popup { width:500px; }</style><p>{{'ERROR_CONTENIDO' | translate}}<p/>",
                            scope: $scope,
                            buttons: [
                             {
                               text: "<b>"+$translate.instant('ACEPTAR')+"</b>",
                               type: 'button-positive',
                               onTap: function(){
                                $rootScope.ocultarNavBar = false;
                                 $scope.itCategorias($stateParams.usuario);
                               }
                             }
                            ]
                          });
                      }else{
                        FactoriaTodo.getBanners()
                          .success(function(eventsB) {
                              //console.log(events.d.replace(/[\u0009]/g, ''));
                              //userInput.replace(/[\u200B-\u200D\uFEFF]/g, '');
                              events.d = events.d.replace(/[\u0009]/g, ''); // Eliminamos el caracter &#x0009; que viene
                              $rootScope.Categorias = JSON.parse(events.d).Categorias;
                              $rootScope.arrayBanners = JSON.parse(eventsB.d);
                              console.log($rootScope.arrayBanners);
                              // Movida para comprobar si la imagen esta disponible
                              $rootScope.Categorias.forEach(function(elemento){
                                imageExists(elemento.imgCategoria, function(exists) {
                                 if(!exists){
                                  elemento.imgCategoria = "img/logobanner.png"
                                 }
                                });
                                //ahora para las subcategorias
                                elemento.subcategorias.forEach(function(subelemento){
                                  imageExists(subelemento.imgSubcategoria, function(exists2) {
                                   if(!exists2){
                                    subelemento.imgSubcategoria = "img/logobanner.png"
                                   }
                                  });
                                });
                              });
                              console.log($rootScope.Categorias);
                              console.log($rootScope.arrayBanners);
                              $ionicLoading.hide();
                              $rootScope.ocultarNavBar = false;
                              $scope.itCategorias($stateParams.usuario);
                            })
                          .error(function(eventsB) {
                              $rootScope.Categorias = JSON.parse(events.d).Categorias;
                              $rootScope.arrayBanners = [];
                              console.log($rootScope.arrayBanners);
                              console.log($rootScope.Categorias);
                              $ionicLoading.hide();
                              $rootScope.ocultarNavBar = false;
                              $scope.itCategorias($stateParams.usuario);
                            })
                      }
                    })
                    .error(function(events) {
                      $ionicLoading.hide();
                         $ionicPopup.show({
                            title: $translate.instant('ERROR'),
                            template: "<style>.popup { width:500px; }</style><p>{{'ERROR_SERVIDOR' | translate}}<p/>",
                            scope: $scope,
                            buttons: [
                             {
                               text: "<b>"+$translate.instant('ACEPTAR')+"</b>",
                               type: 'button-positive'
                             }
                            ]
                          });
                    })
              }else{
                 $ionicLoading.hide();
                 $ionicPopup.show({
                            title: $translate.instant('ERROR'),
                            template: "<style>.popup { width:500px; }</style><p>{{'ERROR_INTERNET' | translate}}<p/>",
                            scope: $scope,
                            buttons: [
                             {
                               text: "<b>"+$translate.instant('ACEPTAR')+"</b>",
                               type: 'button-positive'
                             }
                            ]
                          });
              }
             }, 500);

               console.log(2);
      })
    }

        // mirar si es la primera vez que se ejecuta
    if (localStorage.getItem("LS_EnvioDatos")) {
        // *-- Los datos ya se han enviado --*
         $scope.cargarCategorias();
    } else {
        // *-- No se han enviado los datos cargar slogan--*
      $scope.mostrarEncuesta = true;
      $ionicLoading.show({
              templateUrl: 'views/Extras/cargando.html',
              duration: 200000
          }).then(function() {
        FactoriaTodo.getSlogan()
          .success(function(events) {
                console.log(events);
                $ionicLoading.hide();
                if(events.d == "" || events.d == "[]"){
                  $scope.slogan = "التلفزيون برؤية جديدة‎‎";
                }else{
                  var a = JSON.parse(events.d);
                  console.log(a);
                  $scope.slogan = a[0].Texto;
                }
              })
          .error(function(events) {
            console.log(events);
            $ionicLoading.hide();
          })
      })

    }

    $scope.enviarDatosMovil = function(){

      // var alertPopup = $ionicPopup.alert({
      //   title: 'JSON datos',
      //   template: "<textarea  style='height: 334px;'>"+JSON.stringify(data)+"</textarea>"
      // });

      $ionicLoading.show({
            templateUrl: 'views/Extras/cargando.html',
            duration: 200000
        }).then(function() {
          /*var data = {
              "uuid": $cordovaDevice.getUUID(),
              "marca":$cordovaDevice.getManufacturer(),
              "modelo":$cordovaDevice.getModel(),
              "version":$cordovaDevice.getVersion(),
              "edad":$scope.dato.Edad,
              "sexo":$scope.dato.Sexo.toString(),
              "email":$scope.dato.Correo
          };*/
                
                if ($scope.dato.Edad == "" || $scope.dato.Edad == undefined){
                    $scope.dato.Edad = 0;
                }
                if ($scope.dato.Sexo == "" || $scope.dato.Sexo == undefined){
                    $scope.dato.Sexo = 0;
                }
                if ($scope.dato.Correo == "" || $scope.dato.Correo == undefined){
                    $scope.dato.Correo = "noemail@registration.com";
                }
                
            var data = {
                "uuid": $cordovaDevice.getUUID(),
                "marca":$cordovaDevice.getManufacturer(),
                "modelo":$cordovaDevice.getModel(),
                "version":$cordovaDevice.getVersion(),
                "edad":$scope.dato.Edad,
                "sexo":$scope.dato.Sexo.toString(),
                "email":$scope.dato.Correo
            };
        FactoriaTodo.setNuevoUsuario(data)
          .success(function(events) {
                localStorage.setItem("LS_EnvioDatos", "si");
                console.log(events);
                 $ionicLoading.hide();
                // alert("SUCCES "+JSON.stringify(events));
                 $scope.cargarCategorias();

              })
          .error(function(events) {
            console.log(events);
            // alert("ERROR "+JSON.stringify(events));
            $ionicLoading.hide();
            $ionicPopup.show({
              title: $translate.instant('ERROR'),
              template: "<style>.popup { width:500px; }</style><p>{{'ERROR_INTERNET' | translate}}<p/>",
              scope: $scope,
              buttons: [
               {
                 text: "<b>"+$translate.instant('ACEPTAR')+"</b>",
                 type: 'button-positive'
               }
              ]
            });
          })
      })
    }

    $scope.enviarDatos = function() {

        //enviar datos
        //if($scope.dato.Edad == undefined || $scope.dato.Correo == undefined || $scope.dato.Sexo == undefined || !$scope.dato.Check){
          //$scope.botonClickado = true;
          //console.log($scope.dato.Edad);
          //console.log($scope.dato.Correo);
          //console.log($scope.dato.Sexo);
          //console.log($scope.dato.Check);
          //$scope.cargarCategorias(); //gggg trampas
        //}
        if(!$scope.dato.Check){
            $scope.botonClickado = true;
            console.log($scope.dato.Edad);
            console.log($scope.dato.Correo);
            console.log($scope.dato.Sexo);
            console.log($scope.dato.Check);
        //$scope.cargarCategorias(); //gggg trampas
        } else{
          //enviar datos
          if(window.cordova){
            $scope.enviarDatosMovil();
          }else{
             $scope.cargarCategorias();
             localStorage.setItem("LS_EnvioDatos", "si");
          }

        }


    }
     //Instrucciones movida clases
     //Si se pincha el boton enviar y el campo esta vacio devuelve la clase "required" o lo que te de la gana en el if

    $scope.classEdad=function(){
      if($scope.botonClickado && $scope.dato.Edad == undefined){
        return "required"
      }else{
        return "";
      }
    }

    $scope.classSexo=function(){
      if($scope.botonClickado && $scope.dato.Sexo == undefined){
        return "required"
      }else{
        return "";
      }
    }

    $scope.classCorreo=function(){
      if($scope.botonClickado && $scope.dato.Correo == undefined){
        return "required"
      }else{
        return "";
      }
    }

    $scope.classCheck=function(){
      if($scope.botonClickado && !$scope.dato.Check){
        return "required-checkbox"
      }else{
        return "";
      }
    }

    $scope.mostrarCondiciones = function(){
         $ionicPopup.show({
        title: $translate.instant('CONDICIONES'),
        template: "<style>.popup { width:80%; }</style><p>{{'CONDICIONESLARGO' | translate}}<p/>",
        scope: $scope,
        buttons: [
         {
           text: "<b>"+$translate.instant('CERRAR')+"</b>",
           type: 'button-dark',
         }
        ]
      });
    }


    $scope.probarServicio = function(){
      var a = {};
      a.device = $cordovaDevice.getDevice();
      a.manufacturer = $cordovaDevice.getManufacturer();
      a.model = $cordovaDevice.getModel();
      a.name = $cordovaDevice.getName();
      a.version = $cordovaDevice.getVersion();
      a.UUID = $cordovaDevice.getUUID();
      alert(JSON.stringify(a));
      //        $ionicLoading.show({
      //         templateUrl: 'views/Extras/cargando.html',
      //         duration: 200000
      //     }).then(function() {
      //   FactoriaTodo.CategoriaListarCompleta()
      //     .success(function(events) {
      //           console.log(events);
      //           console.log(JSON.parse(events.d))
      //          $ionicLoading.hide();
      //         })
      //     .error(function(events) {
      //       console.log(events);
      //       $ionicLoading.hide();
      //     })
      // })
    }

    // *-- ------------------------------------------------------------------ --*
})
