angular.module('ListadoVideosController', ['ionic'])

.controller('ListadoVideosController', function($scope, $rootScope, $ionicModal, $ionicLoading, $state, $stateParams, $ionicPopup, $ionicHistory, $ionicPlatform, $translate) {
    // *-- ----------- --*
    // *-- - BOTONES - --*
    // *-- ----------- --*
    // *-- Controlamos los eventos de la pulsación atras para android y boton --*
    // Pulsación atrás Android
    var reg = $ionicPlatform.registerBackButtonAction(function() {
      $scope.atras();
    }, 100);
    //eliminar back button
    $scope.$on('$destroy', reg);
    // Pulsacion atrás Cabecera
    $scope.atras = function() {
      // Menu Principal -> Pantalla de Login
      $ionicHistory.clearHistory();
      $state.go('Subcategorias', {
          usuario: $stateParams.usuario
      });
    }
    $rootScope.movimientoAtras = "Subcategorias";
    $scope.getIcono= function(vid){
      if(vid.video.includes("youtu")){
        return "img/youtube.png"
      }else{
        return "img/videoblanc.png"
      } 
    }
    $scope.titulo=$stateParams.subcategoria;
    $scope.videos = [];
    $rootScope.ListadoVideos.forEach(function(elemento, indice){
      if(indice==0){
        $scope.principal = elemento;
      }else{
        $scope.videos.push(elemento);
      }
    })
    $scope.irVideo = function(vid) {
      console.log(vid);
      if($rootScope.isOnline){
        $rootScope.video = vid;
          if(vid.video.includes("youtu")){  
            $state.go('VideoYT', {
                video: vid
             });
          }else{
            // movida para lo de los anuncios recursivos nuevos
            if(vid.modoPublicidad == '0'){
              // no hay anuncios
              console.log("sin anuncios");
              vid.arrayPubli = [];
              $state.go('Video', {
                video: vid,
                msg: false
              });
            }else{
              vid.arrayPubli = [];
              // hay anuncios
              if(vid.modoPublicidad == '1'){
                // anuncio solo al comienzo
                console.log("Solo inicio");
                vid.anuncios[0].tiempo='0'; //me aseguro de que el tiempo este bien
                vid.arrayPubli.push(vid.anuncios[0]);
                $state.go('Video', {
                  video: vid,
                  msg: false
                });
              }else{
                // habrá anuncios salteados
                 var intervalo = vid.anuncios[0].tiempo;
                  if(intervalo<1){
                    //se han equivocado poner un anuncio al principio y a tirar
                    console.log("Anuncio al principio y a tirar");
                    vid.anuncios[0].tiempo='0'; //me aseguro de que el tiempo este bien
                    vid.arrayPubli.push(vid.anuncios[0]);
                    $state.go('Video', {
                      video: vid,
                      msg: false
                    });
                  }else{
                    // no se han equivocado
                    if(vid.modoPublicidad == '2'){
                      var i = 0;
                    }else{
                      var i = 1;
                    }
                    var cont = 0;
                    var numAnuncios = 20; // Numero de anuncios maximos que mostraremos
                    while(cont < numAnuncios){
                      var v = Object.assign({ }, vid.anuncios[cont%vid.anuncios.length]);
                      v.tiempo = i*intervalo;
                      vid.arrayPubli.push(v);
                      i ++;
                      cont ++; 
                    }
                    $state.go('Video', {
                      video: vid
                    });
                  }
              }
            }
            // fin movida anuncios
           
          }
      }else{
         $ionicPopup.show({
          title: $translate.instant('ERROR'),
          template: "<style>.popup { width:500px; }</style><p>{{'ERROR_INTERNET' | translate}}<p/>",
          scope: $rootScope,
          buttons: [
           {
             text: "<b>"+$translate.instant('ACEPTAR')+"</b>",
             type: 'button-positive'
           }
          ]
        });
      }
        
    }
    // *-- ------------------------------------------------------------------ --*
})
