angular.module('SubcategoriasController', ['ionic'])

.controller('SubcategoriasController', function($scope, $rootScope, $ionicModal, $ionicLoading, $state, $stateParams, $ionicPopup, $ionicHistory, $ionicPlatform, FactoriaTodo, $translate) {

    // *-- ----------- --*
    // *-- - BOTONES - --*
    // *-- ----------- --*
    // *-- Controlamos los eventos de la pulsación atras para android y boton --*
    // Pulsación atrás Android
    var reg = $ionicPlatform.registerBackButtonAction(function() {
      $scope.atras();
    }, 100);
    //eliminar back button
    $scope.$on('$destroy', reg);
    // Pulsacion atrás Cabecera
    $scope.atras = function() {
      // Menu Principal -> Pantalla de Login
      $ionicHistory.clearHistory();
      $state.go('Categorias', {
          usuario: $stateParams.usuario
      });
    }
    //  ------ Buscar banner ------    
    $scope.Banner = $rootScope.arrayBanners.find(function(elemento){
      return elemento.IdCategoria == $rootScope.cat.idCategoria
    });
    console.log("El banner");
    console.log($scope.Banner);
    $rootScope.movimientoAtras = "Categorias";
    $scope.irSubcategoria = function(idSub, nombreSub){
         $ionicLoading.show({
              templateUrl: 'views/Extras/cargando.html',
              duration: 200000
          }).then(function() { 
            if($rootScope.isOnline){
               console.log("CON CONEXION");
                FactoriaTodo.getVideos(idSub)
                  .success(function(events) {
                    // *-- Cargamos la lista videos --*
                    //comprobar que no sea null y que no sea long==0
                    console.log(events);
                    $ionicLoading.hide();
                    if(events.d==""){
                        $ionicPopup.show({
                            title: $translate.instant('ERROR'),
                            template: "<style>.popup { width:500px; }</style><p>{{'ERROR_SERVIDOR' | translate}}<p/>",
                            scope: $scope,
                            buttons: [
                             {
                               text: "<b>"+$translate.instant('ACEPTAR')+"</b>",
                               type: 'button-positive'
                             }
                            ]
                          });
                      }else{
                        $rootScope.ListadoVideos = JSON.parse(events.d).Videos;

                        // Ordenar videos
                        // Mantenemos el primer elemento y le damos la vuelta al resto del array
                        // para mantener la fecha de manera descendente
                        var arrayTemp = $rootScope.ListadoVideos.slice(1);
                        arrayTemp = arrayTemp.reverse();
                        $rootScope.ListadoVideos = $rootScope.ListadoVideos.slice(0,1);
                        $rootScope.ListadoVideos = $rootScope.ListadoVideos.concat(arrayTemp);

                        // alert(JSON.stringify($rootScope.ListadoVideos));
                        // $rootScope.ListadoVideos = events.arrayVideos;
                        $rootScope.ListadoVideos.forEach(function(elemento){
                                  imageExists(elemento.imagen, function(exists) {
                                   if(!exists){
                                    elemento.imagen = "img/negroRoto.jpg"
                                   }
                                  });
                                });
                        console.log($rootScope.ListadoVideos);

                        $rootScope.tituloSubcategoria = nombreSub;
                        $state.go('ListadoVideos', {
                            subcategoria: nombreSub
                        });
                      }
                  })
                  .error(function(events) {
                    console.log(events);
                    $ionicLoading.hide();
                    $ionicPopup.show({
                      title: $translate.instant('ERROR'),
                      template: "<style>.popup { width:500px; }</style><p>{{'ERROR_SERVIDOR' | translate}}<p/>",
                      scope: $scope,
                      buttons: [
                       {
                         text: "<b>"+$translate.instant('ACEPTAR')+"</b>",
                         type: 'button-positive'
                       }
                      ]
                    });
                  })
            }else{
               $ionicPopup.show({
                  title: $translate.instant('ERROR'),
                  template: "<style>.popup { width:500px; }</style><p>{{'ERROR_INTERNET' | translate}}<p/>",
                  scope: $scope,
                  buttons: [
                   {
                     text: "<b>"+$translate.instant('ACEPTAR')+"</b>",
                     type: 'button-positive'
                   }
                  ]
                });
               $ionicLoading.hide();
            }

      })
    }
    $scope.mostrarInfo = function(sub){
      console.log(sub);
      $scope.seleccionada = sub;
      $ionicPopup.show({
        title: $translate.instant('DESCRIPCION'),
        template: "<style>.popup { width:80%; }</style><p>{{seleccionada.descripcionSubcategoria}}<p/>",
        scope: $scope,
        buttons: [
         {
           text: "<b>"+$translate.instant('CERRAR')+"</b>",
           type: 'button-dark'
         },
         {
           text: "<b>"+$translate.instant('VER')+"</b>",
           type: 'button-positive',
           onTap: function() { 
                $scope.irSubcategoria(sub.idSubcategoria , sub.nombreSubcategoria)
            }
         }
        ]
      });

    }
    // *-- ------------------------------------------------------------------ --*
})
