// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
angular.module('starter', [
    'ionic',
    'ngCordova',
    'AccesoController',
    'CategoriasController',
    'SubcategoriasController',
    'ListadoVideosController',
    'VideoController',
    'VideoControllerYT',
    'VideoControllerLive',
    'services',
    "ngSanitize",
    "com.2fdevs.videogular",
    "com.2fdevs.videogular.plugins.controls",
    "com.2fdevs.videogular.plugins.overlayplay",
    "com.2fdevs.videogular.plugins.poster",
    "info.vietnamcode.nampnq.videogular.plugins.youtube",
    'pascalprecht.translate'
])

        .run(function ($cordovaDevice,$translate, $ionicPlatform, $rootScope, $cordovaNetwork, $state, $ionicLoading, FactoriaTodo, $ionicPopup) {
            $rootScope.ocultarNavBar = true;
            $rootScope.cambiarIdioma= false;
            
            $ionicPlatform.ready(function () {
              

              
                if (window.cordova && window.cordova.plugins.Keyboard) {
                    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
                    // for form inputs)
                    cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);

                    // Don't remove this line unless you know what you are doing. It stops the viewport
                    // from snapping when text inputs are focused. Ionic handles this internally for
                    // a much nicer keyboard experience.
                    cordova.plugins.Keyboard.disableScroll(true);
                }
                if (window.StatusBar) {
                    StatusBar.styleDefault();
                }
                if (window.cordova) {
                    // *-------------------------------*
                    // *-- FUNCIONA SOLO EN EL MÓVIL --*
                    // *-------------------------------*
                    // *- Comprobamos la conexion -*
                    // Vemos si hay conexión o no para guardarlo en $rootScope
                    $rootScope.isOnline = $cordovaNetwork.isOnline();
                    // Evento para cuando vuelva la conexión
                    $rootScope.$on('$cordovaNetwork:online', function (event, networkState) {
                        $rootScope.isOnline = true;
                        //console.log("hay conexion");
                    })
                    // Evento para cuando se pierda la conexión
                    $rootScope.$on('$cordovaNetwork:offline', function (event, networkState) {
                        $rootScope.isOnline = false;
                        //console.log("se ha ido conexion");
                    });

                  // Lo del sonido al comienzo 
                  // window.plugins.NativeAudio.preloadSimple( 'click', 'audio/elevator.mp3', function(msg){
                  //   }, function(msg){
                  //     console.log( 'error: ' + msg );
                  //   });

                  // // Play
                  // window.plugins.NativeAudio.play( 'click' );

                  // // Stop multichannel clip after 60 seconds
                  // window.setTimeout( function(){
                  //   window.plugins.NativeAudio.unload( 'click' );
                  // }, 1000 * 60 );

                } else {
                    // *-----------------------------------*
                    // *-- FUNCIONA SOLO EN EL NAVEGADOR --*
                    // *-----------------------------------*
                    $rootScope.isOnline = true;
                }
              if(window.cordova){
                //FCMPlugin.getToken( successCallback(token), errorCallback(err) );
                //Keep in mind the function will return null if the token has not been established yet.
                FCMPlugin.getToken(
                    function (token) {
                        // alert('Token: ' + token);
                        console.log('Token: ' + token);
                        $rootScope.token = token;
                    },
                    function (err) {
                        // alert('error retrieving token: ' + token);
                        console.log('error retrieving token: ' + err);
                        $rootScope.token = "error";
                    }
                );

                FCMPlugin.onNotification(
                    function(data){
                        if(data.wasTapped){
                //Notification was received on device tray and tapped by the user.
                // Aplicacion en 2º plano y pinchado mensaje de barra notificaciones
                            // alert("Tapped: " +  JSON.stringify(data) );
                            console.log("llega:");
                            console.log(JSON.stringify(data));
                            var vid = JSON.parse(data.content);
                            $rootScope.irVideoMsg(vid);
                        }else{
                //Notification was received in foreground. Maybe the user needs to be notified.
                // Aplicacion en 1er plano. Usuario no ha pinchado. Accion instantanea
                            // alert("Not tapped: " + JSON.stringify(data) );
                            console.log("Notificacion:");
                            console.log(data);
                            $rootScope.MostrarNotificacion(data,  $cordovaDevice.getPlatform(),  $cordovaDevice.getVersion());
                        }
                    },
                    function(msg){
                        // alert('onNotification callback successfully registered: ' + msg);
                        console.log('onNotification callback successfully registered: ' + msg);
                    },
                    function(err){
                        // alert('Error registering onNotification callback: ' + err);
                        console.log('Error registering onNotification callback: ' + err);
                    }
                );
                FCMPlugin.subscribeToTopic('all');
                // Registrar OnClick de las notificaciones locales
                cordova.plugins.notification.local.on("click", function(not){
                  // alert(JSON.parse(not.data));
                  // console.log("clicado");
                  // console.log(not);
                  // console.log(JSON.stringify(not));
                  $rootScope.irVideoMsg((not.data));
                });
            }
            // fin push
              });
                $rootScope.MostrarNotificacion = function(msg, plat, vers){ 
                  var data = JSON.parse(msg.content);
                  if(plat == "Android@@" && vers[0]>= 8){
                    console.log("mostramosToast");
                    window.plugins.toast.showWithOptions(
                    {
                      message: data.tituloNotificacion+"  " + data.textoNotificacion,
                      duration: "long", // which is 2000 ms. "long" is 4000. Or specify the nr of ms yourself.
                      position: "bottom",
                      addPixelsY: -40  // added a negative value to move it up a bit (default 0)
                    }
                  );
                  }else{
                    console.log("Mostramos Notification")+
                    console.log("me llega esto");
                    console.log(JSON.stringify(data));
                    console.log(data.tituloNotificacion);
                    console.log(data.textoNotificacion);
                    cordova.plugins.notification.local.schedule({
                      title: data.tituloNotificacion,
                      text: data.textoNotificacion,
                      smallIcon: 'file://img/fcm_push_icon.png',
                      // foreground: true,
                      data: data,
                      color: "C50505"
                    });
                  }

                  }
                  $rootScope.probarNotificacion = function(){ 
                    if(window.cordova){
                      console.log("TOASTI");
                      window.plugins.toast.showWithOptions(
                        {
                          message: "hey there",
                          duration: "long", // which is 2000 ms. "long" is 4000. Or specify the nr of ms yourself.
                          position: "bottom",
                          addPixelsY: -40  // added a negative value to move it up a bit (default 0)
                        }
                      );
                      // console.log("probarNotificacion");
                      //   cordova.plugins.notification.local.schedule({
                      //     title: 'probarNotificacion',
                      //     text: "text"
                      //     // foreground: true,
                      //     // icon: 'file://img/fcm_push_icon.png',
                      //     // color: "C50505"
                      //   });

                        // alert(JSON.stringify(cordova.plugins.notification.local.getDefaults()));
                    }else{
                      $rootScope.irVideoMsg(2);
                    }
                  }
                  $rootScope.suscribeDebug = function(){
                    // alert("suscrito a DEBUG");
                    //  FCMPlugin.subscribeToTopic('debug');
                  }
                $rootScope.irLive= function(){
                       $ionicLoading.show({
                          templateUrl: 'views/Extras/cargando.html',
                          duration: 200000
                      }).then(function() { 
                        if($rootScope.isOnline){
                           console.log("CON CONEXION");
                            FactoriaTodo.getUrlLive()
                              .success(function(events) {
                              	//guardar de alguna manera la respuesta
                                $ionicLoading.hide();
                                if(events.d=="" || events.d == "[]"){
                                    $state.go('VideoLive', {
                                                video: "https://livestream.com/accounts/27130247/events/8196478/player?width=1280&height=720&enableInfoAndActivity=true&defaultDrawer=&autoPlay=true&mute=false"
                                            });
                                    
                                  }else{
                                    $state.go('VideoLive', {
                                                video: JSON.parse(events.d).Url
                                            });
                                  }
                                
                              })
                              .error(function(events) {
                                console.log(events);
                                $ionicLoading.hide();
                                $ionicPopup.show({
                            title: $translate.instant('ERROR'),
                            template: "<style>.popup { width:500px; }</style><p>{{'ERROR_SERVIDOR' | translate}}<p/>",
                            scope: $rootScope,
                            buttons: [
                             {
                               text: "<b>"+$translate.instant('ACEPTAR')+"</b>",
                               type: 'button-positive'
                             }
                            ]
                          });
                              })
                        }else{
                           $ionicPopup.show({
                            title: $translate.instant('ERROR'),
                            template: "<style>.popup { width:500px; }</style><p>{{'ERROR_INTERNET' | translate}}<p/>",
                            scope: $rootScope,
                            buttons: [
                             {
                               text: "<b>"+$translate.instant('ACEPTAR')+"</b>",
                               type: 'button-positive'
                             }
                            ]
                          });
                           $ionicLoading.hide();
                        }

                  })              	
                }
                $rootScope.irVideoMsg = function (vid){
                   $rootScope.vengoDeMsg = true;
                  if(!window.cordova){
                    var vid = {
                      "id": "87f58f51-eece-4a39-9442-bea6bb5beb8d",
                      "titulo": "مفيد يرد على أنصار الجيش ويكشف نقط قوة فاخر",
                      "descripcion": "كليسة المونديال : مفيد يرد على أنصار الجيش ويكشف نقط قوة فاخر",
                      "imagen": "https://www.telemaroc.tv/AppMovil/Videos/updates/Glissa/min4.jpg",
                      "video": "https://www.telemaroc.tv/AppMovil/Videos/updates/Glissa/3.mp4",
                      "urlCompartida": "https://www.telemaroc.tv/p/glissa-riyadiya/episode/2987",
                      "formato": "mp4",
                      "modoPublicidad": "0",
                      "anuncios": [
                        {}
                      ]
                    };
                  }
                    
                  
                  console.log("video:");
                  console.log(JSON.stringify(vid));
                  if($rootScope.isOnline){
                    $rootScope.video = vid;
                      if(vid.video.includes("youtu")){  
                        $state.go('VideoYT', {
                            video: vid
                         });
                      }else{
                        // movida para lo de los anuncios recursivos nuevos
                        if(vid.modoPublicidad == '0'){
                          // no hay anuncios
                          console.log("sin anuncios");
                          vid.arrayPubli = [];
                          $state.go('Video', {
                            video: vid,
                            msg: true
                          });
                        }else{
                          vid.arrayPubli = [];
                          // hay anuncios
                          if(vid.modoPublicidad == '1'){
                            // anuncio solo al comienzo
                            console.log("Solo inicio");
                            vid.anuncios[0].tiempo='0'; //me aseguro de que el tiempo este bien
                            vid.arrayPubli.push(vid.anuncios[0]);
                            $state.go('Video', {
                              video: vid,
                              msg: true
                            });
                          }else{
                            // habrá anuncios salteados
                             var intervalo = vid.anuncios[0].tiempo;
                              if(intervalo<1){
                                //se han equivocado poner un anuncio al principio y a tirar
                                console.log("Anuncio al principio y a tirar");
                                vid.anuncios[0].tiempo='0'; //me aseguro de que el tiempo este bien
                                vid.arrayPubli.push(vid.anuncios[0]);
                                $state.go('Video', {
                                  video: vid,
                                  msg: true
                                });
                              }else{
                                // no se han equivocado
                                if(vid.modoPublicidad == '2'){
                                  var i = 0;
                                }else{
                                  var i = 1;
                                }
                                var cont = 0;
                                var numAnuncios = 20; // Numero de anuncios maximos que mostraremos
                                while(cont < numAnuncios){
                                  var v = Object.assign({ }, vid.anuncios[cont%vid.anuncios.length]);
                                  v.tiempo = i*intervalo;
                                  vid.arrayPubli.push(v);
                                  i ++;
                                  cont ++; 
                                }
                                $state.go('Video', {
                                  video: vid,
                                  msg: true
                                });
                              }
                          }
                        }
                        // fin movida anuncios
                       
                      }
                  }else{
                     $ionicPopup.show({
                      title: $translate.instant('ERROR'),
                      template: "<style>.popup { width:500px; }</style><p>{{'ERROR_INTERNET' | translate}}<p/>",
                      scope: $rootScope,
                      buttons: [
                       {
                         text: "<b>"+$translate.instant('ACEPTAR')+"</b>",
                         type: 'button-positive'
                       }
                      ]
                    });
                  }
                    
                }
                  
                $rootScope.irSubcategoriaR = function(idSub, nombreSub){
                     $ionicLoading.show({
                          templateUrl: 'views/Extras/cargando.html',
                          duration: 200000
                      }).then(function() { 
                        if($rootScope.isOnline){
                           console.log("CON CONEXION");
                            FactoriaTodo.getVideos(idSub)
                              .success(function(events) {
                                // *-- Cargamos la lista videos --*
                                //comprobar que no sea null y que no sea long==0
                                if(events.d==""){
                                    $ionicLoading.hide();
                                    $ionicPopup.show({
                                        title: $translate.instant('ERROR'),
                                        template: "<style>.popup { width:500px; }</style><p>{{'ERROR_SERVIDOR' | translate}}<p/>",
                                        scope: $rootScope,
                                        buttons: [
                                         {
                                           text: "<b>"+$translate.instant('ACEPTAR')+"</b>",
                                           type: 'button-positive'
                                         }
                                        ]
                                      });
                                  }else{
                                    $ionicLoading.hide();
                                            $rootScope.ListadoVideos = JSON.parse(events.d).Videos;
                                            console.log($rootScope.ListadoVideos);
                                            $rootScope.tituloSubcategoria = nombreSub;
                                            $state.go('ListadoVideos', {
                                                subcategoria: nombreSub
                                            });
                                  }
                                
                              })
                              .error(function(events) {
                                $ionicLoading.hide();
                               $ionicPopup.show({
                            title: $translate.instant('ERROR'),
                            template: "<style>.popup { width:500px; }</style><p>{{'ERROR_SERVIDOR' | translate}}<p/>",
                            scope: $rootScope,
                            buttons: [
                             {
                               text: "<b>"+$translate.instant('ACEPTAR')+"</b>",
                               type: 'button-positive'
                             }
                            ]
                          });
                              })
                        }else{
                           $ionicPopup.show({
                            title: $translate.instant('ERROR'),
                            template: "<style>.popup { width:500px; }</style><p>{{'ERROR_INTERNET' | translate}}<p/>",
                            scope: $rootScope,
                            buttons: [
                             {
                               text: "<b>"+$translate.instant('ACEPTAR')+"</b>",
                               type: 'button-positive'
                             }
                            ]
                          });
                           $ionicLoading.hide();
                        }

                  })
                }
                $rootScope.mostrarCat = function (cat) {
                    var antiguo = cat.mostrar;
                    $rootScope.Categorias.forEach(function(elemento){
                        elemento.mostrar=false;
                    });
                   cat.mostrar= !antiguo;
                }
                $rootScope.irSubCat = function (cat, sub) {
                    $rootScope.cat = cat;
                    $rootScope.Subcategorias = cat.subcategorias;
                    $rootScope.tituloCategoria = cat.nombreCategoria;
                    $rootScope.irSubcategoriaR(sub.idSubcategoria, sub.nombreSubcategoria);
                }
                $rootScope.salirR = function(){
                  $ionicPopup.show({
                     title: $translate.instant('SALIR'),
                    template: "<style>.popup { width:500px; }</style><p>{{'COMENTARIO_SALIR' | translate}}<p/>",
                    scope: $rootScope,
                    buttons: [
                    { text: $translate.instant('NO') },
                     {
                       text: "<b>"+$translate.instant('SI')+"</b>",
                       type: 'button-positive',
                       onTap: function() { 
                          if(window.cordova){
                                ionic.Platform.exitApp();
                            }else{
                                $state.go("Acceso");
                            }
                      }
                     }
                    ]
                  });
                }
                $rootScope.atrasR = function () {
                   $rootScope.vengoDeMsg = false;
                    console.log($rootScope.movimientoAtras);
                    //paramos los intervalos de los videos (por si acaso)
                        clearInterval($rootScope.intervalo);
                        clearInterval($rootScope.Intervalo2);
                    if ($rootScope.movimientoAtras == "Salir") {
                           $ionicPopup.show({
                                 title: $translate.instant('SALIR'),
                                template: "<style>.popup { width:500px; }</style><p>{{'COMENTARIO_SALIR' | translate}}<p/>",
                                scope: $rootScope,
                                buttons: [
                                { text: $translate.instant('NO') },
                                 {
                                   text: "<b>"+$translate.instant('SI')+"</b>",
                                   type: 'button-positive',
                                   onTap: function() { 
                                      if(window.cordova){
                                            ionic.Platform.exitApp();
                                        }else{
                                            $state.go("Acceso");
                                        }
                                  }
                                 }
                                ]
                              });
                    } else {
                      if($rootScope.movimientoAtras == "" ||$rootScope.movimientoAtras == undefined ){
                        console.log("-----ERA undefined ---------");
                        $rootScope.movimientoAtras = "Acceso";
                      }
                        $state.go($rootScope.movimientoAtras, {
                            usuario: null
                        });
                    }
                }
                $rootScope.ocultarAtras = function () {
                    if ($rootScope.movimientoAtras == "Salir") {
                        return true;
                    } else {
                        return false;
                    }
                }
                $rootScope.cambiarIdioma = function(idioma){
                   $translate.use(idioma);
                   $rootScope.IdiomaSeleccionado=idioma;
                }
                $rootScope.claseIdioma=function(idioma){
                  if(idioma==$rootScope.IdiomaSeleccionado){
                    return "idiomaSeleccionado";
                  }
                }
                $rootScope.ocultarBarraReproductor=function(){
                  var a = document.querySelector("head");
                  a.innerHTML=a.innerHTML + "<style type='text/css' id='ocultarBarraVideo'>video::-webkit-media-controls-panel {display: none;}</style>";     
                  console.log("-------------------------------ocultarBarraReproductor-------------");
                }
                $rootScope.desocultarBarraReproductor=function(){
                  var b = document.querySelector("#ocultarBarraVideo");
                  if (b == null){
                    
                  }else{
                    b.remove();
                    console.log("-------------------------------DESocultarBarraReproductor-------------");
                  }
                }
        })
        .config(function ($stateProvider, $urlRouterProvider, $translateProvider) {
            $translateProvider.translations('es', traduccion_es);
            $translateProvider.translations('fr', traduccion_fr);
            $translateProvider.translations('ar', traduccion_ar);
            $translateProvider.useSanitizeValueStrategy('escape');
            $stateProvider
                    // *------------*
                    // *-- Acceso --*
                    // *------------*
                    .state('Acceso', {
                        url: '/Acceso',
                        cache: false,
                        templateUrl: 'views/Acceso/Acceso.html',
                        controller: 'AccesoController',
                        params: {}
                    })
                    // *----------------*
                    // *-- CATEGORIAS --*
                    // *----------------*
                    .state('Categorias', {
                        url: '/Categorias',
                        cache: false,
                        templateUrl: 'views/Menu/Categorias.html',
                        controller: 'CategoriasController',
                        params: {
                            usuario: null
                        }
                    })
                    // *--------------------*
                    // *-- Subcategorias  --*
                    // *--------------------*
                    .state('Subcategorias', {
                        url: '/Subcategorias',
                        cache: false,
                        templateUrl: 'views/Menu/Subcategorias.html',
                        controller: 'SubcategoriasController',
                        params: {
                            categoria: null
                        }
                    })
                    //*---------------------*
                    // *-- Listado Videos --*
                    // *--------------------*
                    .state('ListadoVideos', {
                        url: '/ListadoVideos',
                        cache: false,
                        templateUrl: 'views/Videos/ListadoVideos.html',
                        controller: 'ListadoVideosController',
                        params: {
                            subcategoria: null
                        }
                    })
                    //*------------*
                    // *-- Video --*
                    // *-----------*
                    .state('Video', {
                        url: '/Video',
                        cache: false,
                        templateUrl: 'views/Videos/Video.html',
                        controller: 'VideoController',
                        params: {
                            video: null,
                            msg: null
                        }
                    })
                    //*------------*
                    // *-- Video YT--*
                    // *-----------*
                    .state('VideoYT', {
                        url: '/VideoYT',
                        cache: false,
                        templateUrl: 'views/Videos/VideoYT.html',
                        controller: 'VideoControllerYT',
                        params: {
                            video: null
                        }
                    })
                    //*------------*
                    // *-- Video LIVE--*
                    // *-----------*
                    .state('VideoLive', {
                        url: '/VideoLive',
                        cache: false,
                        templateUrl: 'views/Videos/VideoLive.html',
                        controller: 'VideoControllerLive',
                        params: {
                            video: null
                        }
                    })
            // *- En el caso de que no se ponga ninguna direccion -*
            $urlRouterProvider.otherwise('/Acceso');
        })
